#procedure alternativefofa(j,code,printfofa)
 
* This file is part of aITALC
* Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
*-------------------------------------------------------------
** Procedure that calculates and save the form factors in an
** alternative basis to massivefofa.
 
** Begun on, 11/07/05
 
** They should be brought to a given order

** Cases with 2 potential matrix elements, same dirac structure
** To remind, function Mom(a,b,mu) composes out of the momenta p1 and p2 belonging to fermion line `a'
** the fourvector (p1+b*p2)(mu). It should behave as vectors do, but has CF definition


** Here we define it for destroy the copy while extracting form factors and test

L [Amplitude,copy]=[Amplitude,`i'];
.sort
*hide [Amplitude,`i'];


#do i2 = -1,1,2
 #do j2 = -1,1,2
** The TT
id Gb(1,2,`i2',al11,al12)*Gb(2,2,`j2',al21,al22)*Mom(2,-1,al11)*Mom(1,-1,al21)*Delta(al12,al22)=
        Matrixe(`FERMIONCHANNEL',2,`i2',2,`j2',1);
id Gb(1,2,`i2',al11,al12)*Gb(2,2,`j2',al21,al22)*Delta(al11,al21)*Delta(al12,al22)=
        Matrixe(`FERMIONCHANNEL',2,`i2',2,`j2',2);
** The VA or AV in LR notation
id Gb(1,1,`i2',al11,al12)*Gb(2,1,`j2',al21,al22)*Mom(2,-1,al11)*Mom(1,-1,al21)=
        Matrixe(`FERMIONCHANNEL',1,`i2',1,`j2',1);
id Gb(1,1,`i2',al11,al12)*Gb(2,1,`j2',al21,al22)*Delta(al11,al21)=
        Matrixe(`FERMIONCHANNEL',1,`i2',1,`j2',2);

** Cases with 1 potential matrix element, same dirac structure

id Gb(1,2,`i2',al11,al12)*Gb(2,1,`j2',al21,al22)*Mom(2,-1,al11)*Delta(al12,al21)=
        Matrixe(`FERMIONCHANNEL',2,`i2',1,`j2',1);
id Gb(1,1,`i2',al11,al12)*Gb(2,2,`j2',al21,al22)*Mom(1,-1,al21)*Delta(al11,al22)=
        Matrixe(`FERMIONCHANNEL',1,`i2',2,`j2',1);

id Gb(1,1,`i2',al11,al12)*Gb(2,0,`j2',al21,al22)*Mom(2,-1,al11)=
        Matrixe(`FERMIONCHANNEL',1,`i2',0,`j2',1);
id Gb(1,0,`i2',al11,al12)*Gb(2,1,`j2',al21,al22)*Mom(1,-1,al21)=
        Matrixe(`FERMIONCHANNEL',0,`i2',1,`j2',1);

id Gb(1,0,`i2',al11,al12)*Gb(2,0,`j2',al21,al22)=
        Matrixe(`FERMIONCHANNEL',0,`i2',0,`j2',1);
 #enddo
#enddo

.sort
hide [Amplitude,`i'];


** Here we define the amount of elements in matrix element array [i1,i2] for convenience
** and only for the case of 2->2 fermions, later we can modify this alternativefofa for more
** exotic processes.

#$elements22=2;
#$elements11=2;
#$elements21=1;
#$elements12=1;
#$elements10=1;
#$elements01=1;
#$elements00=1;
** moreover there are no elements for other combinations
#$elements02=0;
#$elements20=0;


*print +s -f;
.sort
*---------------------------------------------------------------
* And declaring the new Form Factors variables...
#do ch={`fermioncurrentsnames'}
 #do i1=0,2
  #do i2=-1,1,2
   #do j1=0,2
    #do j2=-1,1,2
     #do el=1,`$elements`i1'`j1''
      G [`ch',`i1',`i2',`j1',`j2',`el']=[Amplitude,copy];
      if ( match(Matrixe(`ch',`i1',`i2',`j1',`j2',`el')) = 0 ) discard;
      id Matrixe(`ch',`i1',`i2',`j1',`j2',`el')=1;
      .sort
      hide  [`ch',`i1',`i2',`j1',`j2',`el'];
     #enddo
    #enddo
   #enddo
  #enddo
 #enddo
#enddo

*print +s -f;
.sort
*---------------------------------------------------------------
* At this point we can expect the next .sort to destroy the copy
drop [Amplitude,copy];
* Test value informs if the result is consistent/incorrect (0/other)
unhide [Amplitude,`i'] ;
#if `printfofa' == 1
** Next unhide allows to load the [Amplitude,copy]
*drop [Amplitude,`i'];
 L test=[Amplitude,`i']
 #do ch={`fermioncurrentsnames'}
  #do i1=0,2
   #do i2=-1,1,2
    #do j1=0,2
     #do j2=-1,1,2
      #do el=1,`$elements`i1'`j1''
       - [FF,`ch',`i1',`i2',`j1',`j2',`el']*Matrixe(`ch',`i1',`i2',`j1',`j2',`el')
      #enddo
     #enddo
    #enddo
   #enddo
  #enddo
 #enddo
 ;
 #message [alternativefofa: Next ist just the test printing]

 print  +s -f test;
 .sort
 drop test;
*  nunhide Rqcopy;
 b Gb,e,sw,i_,Pi;
*  format fortran;
 print +s -f;
#elseif `printfofa' == 0
 b Gb,e,sw,i_,Pi;
 print +s +f;
#else
  #message [alternativefofa: `printfofa' argument neq 0/1. stop]
#endif

.sort
*---------------------------------------------------------------
unhide;
.store
nwrite statistics;
                                                                                
** The final variable is saved as: "FF`ch'`i1'`i2'D`j'"
** in the file FF`code'D`j'

save FF`processname'/FF`code'D`j'.sav [Amplitude,`i'] 
#do ch={`fermioncurrentsnames'}
 #do i1=0,2
  #do i2=-1,1,2
   #do j1=0,2
    #do j2=-1,1,2
      #do el=1,`$elements`i1'`j1''
*      ,[`ch',`i1',`i2',`j1',`j2',`el']
     #enddo
    #enddo
   #enddo
  #enddo
 #enddo
#enddo
;
                                                                                
**Only if running all the diagrams under form.
*delete storage;
                                                                                
#endprocedure
*$$

