#procedure reductionDD02(sorting)

* This file is part of aITALC
* Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
*------------------------------------------------------------- 
** Procedure to reduce scalar tensor integrals to master integrals
** applying the Denner Dittmaier 02 algorithm: hep-ph/0212259
** `sorting' = 1 is more efficient by sorting after substitutions
** Begun on 01/12/02
**----------------------------------------------------------------------

** 4-point functions
#message [reductionDD02: ** Beginning reduction of 4-point integrals] **
id T2(4,1,1)*Targ(PP1?,QQ3?,QQ1?,PP3?,PP2?,QQ2?,MM0?,MM1?,MM2?,MM3?)= +
      IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,PP2,MM0,MM1,MM2)*
      T1(3,1)*(-1/4*PP1*PP2+1/4*PP1*PP3-1/4*PP1*QQ1-1/4*PP2*PP3-1/4*PP2
         *QQ3+1/2*PP2*QQ2-1/4*PP2*QQ1+1/4*PP2^2-1/4*PP3*QQ3+1/4*QQ3*QQ1
         )
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T0(4)*(-MM0*PP2*PP3-MM0*PP2*QQ1+1/2*MM0*PP2^2-
         MM0*PP3*QQ1+1/2*MM0*PP3^2+1/2*MM0*QQ1^2)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T1(4,1)*(1/2*MM0*PP1*QQ1-1/2*MM0*PP2*PP3+1/4*MM0
         *PP2*QQ3-1/4*MM0*PP2*QQ2-3/4*MM0*PP2*QQ1+1/4*MM0*PP2^2-1/4*MM0
         *PP3*QQ3+1/4*MM0*PP3*QQ2-3/4*MM0*PP3*QQ1+1/4*MM0*PP3^2-1/4*MM0
         *QQ3*QQ1-1/4*MM0*QQ2*QQ1+1/2*MM0*QQ1^2+MM1*PP2*PP3+MM1*PP2*QQ1
         -1/2*MM1*PP2^2+MM1*PP3*QQ1-1/2*MM1*PP3^2-1/2*MM1*QQ1^2+1/4*PP1
         *MM2*PP2-1/4*PP1*MM2*PP3-1/4*PP1*MM2*QQ1-1/4*PP1*PP2*MM3-1/2*
         PP1*PP2*PP3-3/4*PP1*PP2*QQ1+1/4*PP1*PP2^2+1/4*PP1*MM3*PP3-1/4*
         PP1*MM3*QQ1-3/4*PP1*PP3*QQ1+1/4*PP1*PP3^2+1/2*PP1*QQ1^2-1/4*
         MM2*PP2*PP3-1/4*MM2*PP2*QQ2+1/2*MM2*PP3*QQ3-1/4*MM2*PP3*QQ2-1/
         4*MM2*PP3*QQ1+1/4*MM2*PP3^2+1/4*MM2*QQ2*QQ1-1/4*PP2*MM3*PP3-1/
         4*PP2*MM3*QQ3+1/2*PP2*MM3*QQ2-1/4*PP2*MM3*QQ1-1/4*PP2*PP3*QQ3-
         1/4*PP2*PP3*QQ2+1/2*PP2*PP3*QQ1-1/4*PP2*QQ2*QQ1+1/4*PP2^2*MM3+
         1/4*PP2^2*QQ2-1/4*MM3*PP3*QQ3+1/4*MM3*QQ3*QQ1-1/4*PP3*QQ3*QQ1+
         1/4*PP3^2*QQ3)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T1(4,2)*(-1/2*MM0*PP2*PP3-1/2*MM0*PP2*QQ1+1/4*
         MM0*PP2^2-1/2*MM0*PP3*QQ1+1/4*MM0*PP3^2+1/4*MM0*QQ1^2+1/2*MM2*
         PP2*PP3+1/2*MM2*PP2*QQ1-1/4*MM2*PP2^2+1/2*MM2*PP3*QQ1-1/4*MM2*
         PP3^2-1/4*MM2*QQ1^2-1/2*PP2*PP3*QQ1+1/4*PP2*PP3^2+1/4*PP2*
         QQ1^2-1/2*PP2^2*PP3-1/2*PP2^2*QQ1+1/4*PP2^3)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T1(4,3)*(-1/2*MM0*PP2*PP3-1/2*MM0*PP2*QQ1+1/4*
         MM0*PP2^2-1/2*MM0*PP3*QQ1+1/4*MM0*PP3^2+1/4*MM0*QQ1^2+1/2*PP2*
         MM3*PP3+1/2*PP2*MM3*QQ1-1/2*PP2*PP3*QQ1-1/2*PP2*PP3^2-1/4*
         PP2^2*MM3+1/4*PP2^2*PP3+1/2*MM3*PP3*QQ1-1/4*MM3*PP3^2-1/4*MM3*
         QQ1^2+1/4*PP3*QQ1^2-1/2*PP3^2*QQ1+1/4*PP3^3)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ2,PP3,MM0,MM1,MM3)*
      T1(3,1)*(1/4*PP1*PP2-1/4*PP1*PP3-1/4*PP1*QQ1-1/4*PP2*PP3-1/4*PP2*
         QQ2+1/2*PP3*QQ3-1/4*PP3*QQ2-1/4*PP3*QQ1+1/4*PP3^2+1/4*QQ2*QQ1)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(QQ3,QQ1,QQ2,MM1,MM2,MM3)*
      T0(3)*(-1/2*PP1*QQ1-1/2*PP2*PP3-1/4*PP2*QQ3+1/4*PP2*QQ2-1/4*PP2*
         QQ1+1/4*PP2^2+1/4*PP3*QQ3-1/4*PP3*QQ2-1/4*PP3*QQ1+1/4*PP3^2+1/
         4*QQ3*QQ1+1/4*QQ2*QQ1)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(QQ3,QQ1,QQ2,MM1,MM2,MM3)*
      T1(3,1)*(-1/2*PP1*QQ1-1/4*PP2*QQ3+1/4*PP2*QQ2+1/4*PP2*QQ1+1/4*PP3
         *QQ3-1/4*PP3*QQ2+1/4*PP3*QQ1+1/4*QQ3*QQ1+1/4*QQ2*QQ1-1/4*QQ1^2
         )
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(QQ3,QQ1,QQ2,MM1,MM2,MM3)*
      T1(3,2)*(-1/2*PP1*QQ1-1/4*PP2*QQ3+1/4*PP2*QQ2+1/4*PP2*QQ1+1/4*PP3
         *QQ3-1/4*PP3*QQ2+1/4*PP3*QQ1+1/4*QQ3*QQ1+1/4*QQ2*QQ1-1/4*QQ1^2
         );
#if `sorting' == 1
.sort
#endif

id T2(4,1,2)*Targ(PP1?,QQ3?,QQ1?,PP3?,PP2?,QQ2?,MM0?,MM1?,MM2?,MM3?)= +
      IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,PP2,MM0,MM1,MM2)*
      T1(3,2)*(-1/4*PP1*PP2+1/4*PP1*PP3-1/4*PP1*QQ1-1/4*PP2*PP3-1/4*PP2
         *QQ3+1/2*PP2*QQ2-1/4*PP2*QQ1+1/4*PP2^2-1/4*PP3*QQ3+1/4*QQ3*QQ1
         )
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T0(4)*(-1/2*MM0*PP1*PP2+1/2*MM0*PP1*PP3+1/2*MM0*
         PP1*QQ1+1/2*MM0*PP2*PP3+1/2*MM0*PP2*QQ2-MM0*PP3*QQ3+1/2*MM0*
         PP3*QQ2+1/2*MM0*PP3*QQ1-1/2*MM0*PP3^2-1/2*MM0*QQ2*QQ1)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T1(4,1)*(-1/4*MM0*PP1*PP2+1/4*MM0*PP1*PP3+1/4*
         MM0*PP1*QQ1+1/4*MM0*PP2*PP3+1/4*MM0*PP2*QQ2-1/2*MM0*PP3*QQ3+1/
         4*MM0*PP3*QQ2+1/4*MM0*PP3*QQ1-1/4*MM0*PP3^2-1/4*MM0*QQ2*QQ1+1/
         4*MM1*PP1*PP2-1/4*MM1*PP1*PP3-1/4*MM1*PP1*QQ1-1/4*MM1*PP2*PP3-
         1/4*MM1*PP2*QQ2+1/2*MM1*PP3*QQ3-1/4*MM1*PP3*QQ2-1/4*MM1*PP3*
         QQ1+1/4*MM1*PP3^2+1/4*MM1*QQ2*QQ1+1/4*PP1*PP2*PP3+1/4*PP1*PP2*
         QQ2-1/2*PP1*PP3*QQ3+1/4*PP1*PP3*QQ2+1/4*PP1*PP3*QQ1-1/4*PP1*
         PP3^2-1/4*PP1*QQ2*QQ1-1/4*PP1^2*PP2+1/4*PP1^2*PP3+1/4*PP1^2*
         QQ1)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T1(4,2)*(-1/4*MM0*PP1*PP2+1/4*MM0*PP1*PP3+3/4*
         MM0*PP1*QQ1+1/4*MM0*PP2*PP3+1/4*MM0*PP2*QQ3-1/4*MM0*PP2*QQ1-3/
         4*MM0*PP3*QQ3+1/2*MM0*PP3*QQ2-1/4*MM0*PP3^2-1/4*MM0*QQ3*QQ1-1/
         2*MM0*QQ2*QQ1+1/4*MM0*QQ1^2+1/2*MM1*PP2*PP3+1/2*MM1*PP2*QQ1-1/
         4*MM1*PP2^2+1/2*MM1*PP3*QQ1-1/4*MM1*PP3^2-1/4*MM1*QQ1^2+1/2*
         PP1*MM2*PP2-1/2*PP1*MM2*PP3-1/2*PP1*MM2*QQ1-1/4*PP1*PP2*MM3+1/
         4*PP1*PP2*PP3-1/4*PP1*PP2^2+1/4*PP1*MM3*PP3-1/4*PP1*MM3*QQ1-1/
         4*PP1*PP3*QQ1+1/4*PP1*QQ1^2-1/2*MM2*PP2*PP3-1/2*MM2*PP2*QQ2+
         MM2*PP3*QQ3-1/2*MM2*PP3*QQ2-1/2*MM2*PP3*QQ1+1/2*MM2*PP3^2+1/2*
         MM2*QQ2*QQ1-1/4*PP2*MM3*PP3-1/4*PP2*MM3*QQ3+1/2*PP2*MM3*QQ2-1/
         4*PP2*MM3*QQ1-3/4*PP2*PP3*QQ3+3/4*PP2*PP3*QQ1-1/4*PP2*PP3^2-1/
         2*PP2*QQ2*QQ1+1/4*PP2^2*MM3+1/4*PP2^2*PP3+1/2*PP2^2*QQ2-1/4*
         MM3*PP3*QQ3+1/4*MM3*QQ3*QQ1-1/4*PP3*QQ3*QQ1+1/4*PP3^2*QQ3)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T1(4,3)*(-1/4*MM0*PP1*PP2+1/4*MM0*PP1*PP3+1/4*
         MM0*PP1*QQ1+1/4*MM0*PP2*PP3+1/4*MM0*PP2*QQ2-1/2*MM0*PP3*QQ3+1/
         4*MM0*PP3*QQ2+1/4*MM0*PP3*QQ1-1/4*MM0*PP3^2-1/4*MM0*QQ2*QQ1+1/
         4*PP1*PP2*MM3-1/4*PP1*PP2*PP3-1/4*PP1*MM3*PP3-1/4*PP1*MM3*QQ1+
         1/4*PP1*PP3*QQ1+1/4*PP1*PP3^2-1/4*PP2*MM3*PP3-1/4*PP2*MM3*QQ2+
         1/4*PP2*PP3*QQ2+1/4*PP2*PP3^2+1/2*MM3*PP3*QQ3-1/4*MM3*PP3*QQ2-
         1/4*MM3*PP3*QQ1+1/4*MM3*PP3^2+1/4*MM3*QQ2*QQ1-1/4*PP3*QQ2*QQ1-
         1/2*PP3^2*QQ3+1/4*PP3^2*QQ2+1/4*PP3^2*QQ1-1/4*PP3^3)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP2,QQ1,PP3,MM0,MM2,MM3)*
      T1(3,1)*(1/2*PP2*PP3+1/2*PP2*QQ1-1/4*PP2^2+1/2*PP3*QQ1-1/4*PP3^2-
         1/4*QQ1^2)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(QQ3,QQ1,QQ2,MM1,MM2,MM3)*
      T0(3)*(-1/4*PP1*PP2+1/4*PP1*PP3+1/4*PP1*QQ1+1/4*PP2*PP3+1/4*PP2*
         QQ2-1/2*PP3*QQ3+1/4*PP3*QQ2+1/4*PP3*QQ1-1/4*PP3^2-1/4*QQ2*QQ1)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(QQ3,QQ1,QQ2,MM1,MM2,MM3)*
      T1(3,1)*(1/2*PP1*QQ1+1/4*PP2*QQ3-1/4*PP2*QQ2-1/4*PP2*QQ1-1/4*PP3*
         QQ3+1/4*PP3*QQ2-1/4*PP3*QQ1-1/4*QQ3*QQ1-1/4*QQ2*QQ1+1/4*QQ1^2)
         ;
#if `sorting' == 1
.sort
#endif
id T2(4,1,3)*Targ(PP1?,QQ3?,QQ1?,PP3?,PP2?,QQ2?,MM0?,MM1?,MM2?,MM3?)= +
      IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,MM0
      ,MM1,MM2,MM3)*T0(4)*(1/2*MM0*PP1*PP2-1/2*MM0*PP1*PP3+1/2*MM0*PP1*
         QQ1+1/2*MM0*PP2*PP3+1/2*MM0*PP2*QQ3-MM0*PP2*QQ2+1/2*MM0*PP2*
         QQ1-1/2*MM0*PP2^2+1/2*MM0*PP3*QQ3-1/2*MM0*QQ3*QQ1)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T1(4,1)*(1/4*MM0*PP1*PP2-1/4*MM0*PP1*PP3+1/4*MM0
         *PP1*QQ1+1/4*MM0*PP2*PP3+1/4*MM0*PP2*QQ3-1/2*MM0*PP2*QQ2+1/4*
         MM0*PP2*QQ1-1/4*MM0*PP2^2+1/4*MM0*PP3*QQ3-1/4*MM0*QQ3*QQ1-1/4*
         MM1*PP1*PP2+1/4*MM1*PP1*PP3-1/4*MM1*PP1*QQ1-1/4*MM1*PP2*PP3-1/
         4*MM1*PP2*QQ3+1/2*MM1*PP2*QQ2-1/4*MM1*PP2*QQ1+1/4*MM1*PP2^2-1/
         4*MM1*PP3*QQ3+1/4*MM1*QQ3*QQ1+1/4*PP1*PP2*PP3+1/4*PP1*PP2*QQ3-
         1/2*PP1*PP2*QQ2+1/4*PP1*PP2*QQ1-1/4*PP1*PP2^2+1/4*PP1*PP3*QQ3-
         1/4*PP1*QQ3*QQ1+1/4*PP1^2*PP2-1/4*PP1^2*PP3+1/4*PP1^2*QQ1)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T1(4,2)*(1/4*MM0*PP1*PP2-1/4*MM0*PP1*PP3+1/4*MM0
         *PP1*QQ1+1/4*MM0*PP2*PP3+1/4*MM0*PP2*QQ3-1/2*MM0*PP2*QQ2+1/4*
         MM0*PP2*QQ1-1/4*MM0*PP2^2+1/4*MM0*PP3*QQ3-1/4*MM0*QQ3*QQ1-1/4*
         PP1*MM2*PP2+1/4*PP1*MM2*PP3-1/4*PP1*MM2*QQ1-1/4*PP1*PP2*PP3+1/
         4*PP1*PP2*QQ1+1/4*PP1*PP2^2-1/4*MM2*PP2*PP3-1/4*MM2*PP2*QQ3+1/
         2*MM2*PP2*QQ2-1/4*MM2*PP2*QQ1+1/4*MM2*PP2^2-1/4*MM2*PP3*QQ3+1/
         4*MM2*QQ3*QQ1+1/4*PP2*PP3*QQ3-1/4*PP2*QQ3*QQ1+1/4*PP2^2*PP3+1/
         4*PP2^2*QQ3-1/2*PP2^2*QQ2+1/4*PP2^2*QQ1-1/4*PP2^3)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T1(4,3)*(1/4*MM0*PP1*PP2-1/4*MM0*PP1*PP3+3/4*MM0
         *PP1*QQ1+1/4*MM0*PP2*PP3+1/2*MM0*PP2*QQ3-3/4*MM0*PP2*QQ2-1/4*
         MM0*PP2^2+1/4*MM0*PP3*QQ2-1/4*MM0*PP3*QQ1-1/2*MM0*QQ3*QQ1-1/4*
         MM0*QQ2*QQ1+1/4*MM0*QQ1^2+1/2*MM1*PP2*PP3+1/2*MM1*PP2*QQ1-1/4*
         MM1*PP2^2+1/2*MM1*PP3*QQ1-1/4*MM1*PP3^2-1/4*MM1*QQ1^2+1/4*PP1*
         MM2*PP2-1/4*PP1*MM2*PP3-1/4*PP1*MM2*QQ1-1/2*PP1*PP2*MM3+1/4*
         PP1*PP2*PP3-1/4*PP1*PP2*QQ1+1/2*PP1*MM3*PP3-1/2*PP1*MM3*QQ1-1/
         4*PP1*PP3^2+1/4*PP1*QQ1^2-1/4*MM2*PP2*PP3-1/4*MM2*PP2*QQ2+1/2*
         MM2*PP3*QQ3-1/4*MM2*PP3*QQ2-1/4*MM2*PP3*QQ1+1/4*MM2*PP3^2+1/4*
         MM2*QQ2*QQ1-1/2*PP2*MM3*PP3-1/2*PP2*MM3*QQ3+PP2*MM3*QQ2-1/2*
         PP2*MM3*QQ1-3/4*PP2*PP3*QQ2+3/4*PP2*PP3*QQ1+1/4*PP2*PP3^2-1/4*
         PP2*QQ2*QQ1+1/2*PP2^2*MM3-1/4*PP2^2*PP3+1/4*PP2^2*QQ2-1/2*MM3*
         PP3*QQ3+1/2*MM3*QQ3*QQ1-1/2*PP3*QQ3*QQ1+1/2*PP3^2*QQ3)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ2,PP3,MM0,MM1,MM3)*
      T1(3,2)*(1/4*PP1*PP2-1/4*PP1*PP3-1/4*PP1*QQ1-1/4*PP2*PP3-1/4*PP2*
         QQ2+1/2*PP3*QQ3-1/4*PP3*QQ2-1/4*PP3*QQ1+1/4*PP3^2+1/4*QQ2*QQ1)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP2,QQ1,PP3,MM0,MM2,MM3)*
      T1(3,2)*(1/2*PP2*PP3+1/2*PP2*QQ1-1/4*PP2^2+1/2*PP3*QQ1-1/4*PP3^2-
         1/4*QQ1^2)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(QQ3,QQ1,QQ2,MM1,MM2,MM3)*
      T0(3)*(1/4*PP1*PP2-1/4*PP1*PP3+1/4*PP1*QQ1+1/4*PP2*PP3+1/4*PP2*
         QQ3-1/2*PP2*QQ2+1/4*PP2*QQ1-1/4*PP2^2+1/4*PP3*QQ3-1/4*QQ3*QQ1)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(QQ3,QQ1,QQ2,MM1,MM2,MM3)*
      T1(3,2)*(1/2*PP1*QQ1+1/4*PP2*QQ3-1/4*PP2*QQ2-1/4*PP2*QQ1-1/4*PP3*
         QQ3+1/4*PP3*QQ2-1/4*PP3*QQ1-1/4*QQ3*QQ1-1/4*QQ2*QQ1+1/4*QQ1^2)
         ;
#if `sorting' == 1
.sort
#endif
id T2(4,2,2)*Targ(PP1?,QQ3?,QQ1?,PP3?,PP2?,QQ2?,MM0?,MM1?,MM2?,MM3?)= +
      IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,PP2,MM0,MM1,MM2)*
      T1(3,2)*(-1/4*PP1*PP2-1/4*PP1*PP3-1/4*PP1*QQ3-1/4*PP1*QQ2+1/2*PP1
         *QQ1+1/4*PP1^2+1/4*PP2*PP3-1/4*PP2*QQ2-1/4*PP3*QQ3+1/4*QQ3*QQ2
         )
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T0(4)*(-MM0*PP1*PP3-MM0*PP1*QQ2+1/2*MM0*PP1^2-
         MM0*PP3*QQ2+1/2*MM0*PP3^2+1/2*MM0*QQ2^2)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T1(4,1)*(-1/2*MM0*PP1*PP3-1/2*MM0*PP1*QQ2+1/4*
         MM0*PP1^2-1/2*MM0*PP3*QQ2+1/4*MM0*PP3^2+1/4*MM0*QQ2^2+1/2*MM1*
         PP1*PP3+1/2*MM1*PP1*QQ2-1/4*MM1*PP1^2+1/2*MM1*PP3*QQ2-1/4*MM1*
         PP3^2-1/4*MM1*QQ2^2-1/2*PP1*PP3*QQ2+1/4*PP1*PP3^2+1/4*PP1*
         QQ2^2-1/2*PP1^2*PP3-1/2*PP1^2*QQ2+1/4*PP1^3)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T1(4,2)*(-1/2*MM0*PP1*PP3+1/4*MM0*PP1*QQ3-3/4*
         MM0*PP1*QQ2-1/4*MM0*PP1*QQ1+1/4*MM0*PP1^2+1/2*MM0*PP2*QQ2-1/4*
         MM0*PP3*QQ3-3/4*MM0*PP3*QQ2+1/4*MM0*PP3*QQ1+1/4*MM0*PP3^2-1/4*
         MM0*QQ3*QQ2-1/4*MM0*QQ2*QQ1+1/2*MM0*QQ2^2+1/4*MM1*PP1*PP2-1/4*
         MM1*PP1*PP3-1/4*MM1*PP1*QQ1-1/4*MM1*PP2*PP3-1/4*MM1*PP2*QQ2+1/
         2*MM1*PP3*QQ3-1/4*MM1*PP3*QQ2-1/4*MM1*PP3*QQ1+1/4*MM1*PP3^2+1/
         4*MM1*QQ2*QQ1+PP1*MM2*PP3+PP1*MM2*QQ2-1/4*PP1*PP2*MM3-1/2*PP1*
         PP2*PP3-3/4*PP1*PP2*QQ2-1/4*PP1*MM3*PP3-1/4*PP1*MM3*QQ3-1/4*
         PP1*MM3*QQ2+1/2*PP1*MM3*QQ1-1/4*PP1*PP3*QQ3+1/2*PP1*PP3*QQ2-1/
         4*PP1*PP3*QQ1-1/4*PP1*QQ2*QQ1-1/2*PP1^2*MM2+1/4*PP1^2*PP2+1/4*
         PP1^2*MM3+1/4*PP1^2*QQ1+MM2*PP3*QQ2-1/2*MM2*PP3^2-1/2*MM2*
         QQ2^2+1/4*PP2*MM3*PP3-1/4*PP2*MM3*QQ2-3/4*PP2*PP3*QQ2+1/4*PP2*
         PP3^2+1/2*PP2*QQ2^2-1/4*MM3*PP3*QQ3+1/4*MM3*QQ3*QQ2-1/4*PP3*
         QQ3*QQ2+1/4*PP3^2*QQ3)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T1(4,3)*(-1/2*MM0*PP1*PP3-1/2*MM0*PP1*QQ2+1/4*
         MM0*PP1^2-1/2*MM0*PP3*QQ2+1/4*MM0*PP3^2+1/4*MM0*QQ2^2+1/2*PP1*
         MM3*PP3+1/2*PP1*MM3*QQ2-1/2*PP1*PP3*QQ2-1/2*PP1*PP3^2-1/4*
         PP1^2*MM3+1/4*PP1^2*PP3+1/2*MM3*PP3*QQ2-1/4*MM3*PP3^2-1/4*MM3*
         QQ2^2+1/4*PP3*QQ2^2-1/2*PP3^2*QQ2+1/4*PP3^3)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP2,QQ1,PP3,MM0,MM2,MM3)*
      T1(3,1)*(1/4*PP1*PP2-1/4*PP1*PP3-1/4*PP1*QQ1-1/4*PP2*PP3-1/4*PP2*
         QQ2+1/2*PP3*QQ3-1/4*PP3*QQ2-1/4*PP3*QQ1+1/4*PP3^2+1/4*QQ2*QQ1)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(QQ3,QQ1,QQ2,MM1,MM2,MM3)*
      T0(3)*(-1/2*PP1*PP3-1/2*PP1*QQ2+1/4*PP1^2-1/2*PP3*QQ2+1/4*PP3^2+1/
         4*QQ2^2)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(QQ3,QQ1,QQ2,MM1,MM2,MM3)*
      T1(3,1)*(1/4*PP1*QQ3-1/4*PP1*QQ2-1/4*PP1*QQ1+1/2*PP2*QQ2-1/4*PP3*
         QQ3-1/4*PP3*QQ2+1/4*PP3*QQ1-1/4*QQ3*QQ2-1/4*QQ2*QQ1+1/4*QQ2^2)
         ;
#if `sorting' == 1
.sort
#endif
id T2(4,2,3)*Targ(PP1?,QQ3?,QQ1?,PP3?,PP2?,QQ2?,MM0?,MM1?,MM2?,MM3?)= +
      IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,MM0
      ,MM1,MM2,MM3)*T0(4)*(1/2*MM0*PP1*PP2+1/2*MM0*PP1*PP3+1/2*MM0*PP1*
         QQ3+1/2*MM0*PP1*QQ2-MM0*PP1*QQ1-1/2*MM0*PP1^2-1/2*MM0*PP2*PP3+
         1/2*MM0*PP2*QQ2+1/2*MM0*PP3*QQ3-1/2*MM0*QQ3*QQ2)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T1(4,1)*(1/4*MM0*PP1*PP2+1/4*MM0*PP1*PP3+1/4*MM0
         *PP1*QQ3+1/4*MM0*PP1*QQ2-1/2*MM0*PP1*QQ1-1/4*MM0*PP1^2-1/4*MM0
         *PP2*PP3+1/4*MM0*PP2*QQ2+1/4*MM0*PP3*QQ3-1/4*MM0*QQ3*QQ2-1/4*
         MM1*PP1*PP2-1/4*MM1*PP1*PP3-1/4*MM1*PP1*QQ3-1/4*MM1*PP1*QQ2+1/
         2*MM1*PP1*QQ1+1/4*MM1*PP1^2+1/4*MM1*PP2*PP3-1/4*MM1*PP2*QQ2-1/
         4*MM1*PP3*QQ3+1/4*MM1*QQ3*QQ2-1/4*PP1*PP2*PP3+1/4*PP1*PP2*QQ2+
         1/4*PP1*PP3*QQ3-1/4*PP1*QQ3*QQ2+1/4*PP1^2*PP2+1/4*PP1^2*PP3+1/
         4*PP1^2*QQ3+1/4*PP1^2*QQ2-1/2*PP1^2*QQ1-1/4*PP1^3)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T1(4,2)*(1/4*MM0*PP1*PP2+1/4*MM0*PP1*PP3+1/4*MM0
         *PP1*QQ3+1/4*MM0*PP1*QQ2-1/2*MM0*PP1*QQ1-1/4*MM0*PP1^2-1/4*MM0
         *PP2*PP3+1/4*MM0*PP2*QQ2+1/4*MM0*PP3*QQ3-1/4*MM0*QQ3*QQ2-1/4*
         PP1*MM2*PP2-1/4*PP1*MM2*PP3-1/4*PP1*MM2*QQ3-1/4*PP1*MM2*QQ2+1/
         2*PP1*MM2*QQ1+1/4*PP1*PP2*PP3+1/4*PP1*PP2*QQ3+1/4*PP1*PP2*QQ2-
         1/2*PP1*PP2*QQ1+1/4*PP1*PP2^2+1/4*PP1^2*MM2-1/4*PP1^2*PP2+1/4*
         MM2*PP2*PP3-1/4*MM2*PP2*QQ2-1/4*MM2*PP3*QQ3+1/4*MM2*QQ3*QQ2+1/
         4*PP2*PP3*QQ3-1/4*PP2*QQ3*QQ2-1/4*PP2^2*PP3+1/4*PP2^2*QQ2)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T1(4,3)*(1/4*MM0*PP1*PP2+1/4*MM0*PP1*PP3+1/2*MM0
         *PP1*QQ3-3/4*MM0*PP1*QQ1-1/4*MM0*PP1^2-1/4*MM0*PP2*PP3+3/4*MM0
         *PP2*QQ2-1/4*MM0*PP3*QQ2+1/4*MM0*PP3*QQ1-1/2*MM0*QQ3*QQ2-1/4*
         MM0*QQ2*QQ1+1/4*MM0*QQ2^2+1/4*MM1*PP1*PP2-1/4*MM1*PP1*PP3-1/4*
         MM1*PP1*QQ1-1/4*MM1*PP2*PP3-1/4*MM1*PP2*QQ2+1/2*MM1*PP3*QQ3-1/
         4*MM1*PP3*QQ2-1/4*MM1*PP3*QQ1+1/4*MM1*PP3^2+1/4*MM1*QQ2*QQ1+1/
         2*PP1*MM2*PP3+1/2*PP1*MM2*QQ2-1/2*PP1*PP2*MM3+1/4*PP1*PP2*PP3-
         1/4*PP1*PP2*QQ2-1/2*PP1*MM3*PP3-1/2*PP1*MM3*QQ3-1/2*PP1*MM3*
         QQ2+PP1*MM3*QQ1+3/4*PP1*PP3*QQ2-3/4*PP1*PP3*QQ1+1/4*PP1*PP3^2-
         1/4*PP1*QQ2*QQ1-1/4*PP1^2*MM2+1/2*PP1^2*MM3-1/4*PP1^2*PP3+1/4*
         PP1^2*QQ1+1/2*MM2*PP3*QQ2-1/4*MM2*PP3^2-1/4*MM2*QQ2^2+1/2*PP2*
         MM3*PP3-1/2*PP2*MM3*QQ2-1/4*PP2*PP3^2+1/4*PP2*QQ2^2-1/2*MM3*
         PP3*QQ3+1/2*MM3*QQ3*QQ2-1/2*PP3*QQ3*QQ2+1/2*PP3^2*QQ3)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ2,PP3,MM0,MM1,MM3)*
      T1(3,2)*(1/2*PP1*PP3+1/2*PP1*QQ2-1/4*PP1^2+1/2*PP3*QQ2-1/4*PP3^2-
         1/4*QQ2^2)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP2,QQ1,PP3,MM0,MM2,MM3)*
      T1(3,2)*(1/4*PP1*PP2-1/4*PP1*PP3-1/4*PP1*QQ1-1/4*PP2*PP3-1/4*PP2*
         QQ2+1/2*PP3*QQ3-1/4*PP3*QQ2-1/4*PP3*QQ1+1/4*PP3^2+1/4*QQ2*QQ1)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(QQ3,QQ1,QQ2,MM1,MM2,MM3)*
      T0(3)*(1/4*PP1*PP2+1/4*PP1*PP3+1/4*PP1*QQ3+1/4*PP1*QQ2-1/2*PP1*
         QQ1-1/4*PP1^2-1/4*PP2*PP3+1/4*PP2*QQ2+1/4*PP3*QQ3-1/4*QQ3*QQ2)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(QQ3,QQ1,QQ2,MM1,MM2,MM3)*
      T1(3,2)*(1/4*PP1*QQ3-1/4*PP1*QQ2-1/4*PP1*QQ1+1/2*PP2*QQ2-1/4*PP3*
         QQ3-1/4*PP3*QQ2+1/4*PP3*QQ1-1/4*QQ3*QQ2-1/4*QQ2*QQ1+1/4*QQ2^2)
         ;
#if `sorting' == 1
.sort
#endif
id T2(4,3,3)*Targ(PP1?,QQ3?,QQ1?,PP3?,PP2?,QQ2?,MM0?,MM1?,MM2?,MM3?)= +
      IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,MM0
      ,MM1,MM2,MM3)*T0(4)*(-MM0*PP1*PP2-MM0*PP1*QQ3+1/2*MM0*PP1^2-MM0*
         PP2*QQ3+1/2*MM0*PP2^2+1/2*MM0*QQ3^2)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T1(4,1)*(-1/2*MM0*PP1*PP2-1/2*MM0*PP1*QQ3+1/4*
         MM0*PP1^2-1/2*MM0*PP2*QQ3+1/4*MM0*PP2^2+1/4*MM0*QQ3^2+1/2*MM1*
         PP1*PP2+1/2*MM1*PP1*QQ3-1/4*MM1*PP1^2+1/2*MM1*PP2*QQ3-1/4*MM1*
         PP2^2-1/4*MM1*QQ3^2-1/2*PP1*PP2*QQ3+1/4*PP1*PP2^2+1/4*PP1*
         QQ3^2-1/2*PP1^2*PP2-1/2*PP1^2*QQ3+1/4*PP1^3)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T1(4,2)*(-1/2*MM0*PP1*PP2-1/2*MM0*PP1*QQ3+1/4*
         MM0*PP1^2-1/2*MM0*PP2*QQ3+1/4*MM0*PP2^2+1/4*MM0*QQ3^2+1/2*PP1*
         MM2*PP2+1/2*PP1*MM2*QQ3-1/2*PP1*PP2*QQ3-1/2*PP1*PP2^2-1/4*
         PP1^2*MM2+1/4*PP1^2*PP2+1/2*MM2*PP2*QQ3-1/4*MM2*PP2^2-1/4*MM2*
         QQ3^2+1/4*PP2*QQ3^2-1/2*PP2^2*QQ3+1/4*PP2^3)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T1(4,3)*(-1/2*MM0*PP1*PP2-3/4*MM0*PP1*QQ3+1/4*
         MM0*PP1*QQ2-1/4*MM0*PP1*QQ1+1/4*MM0*PP1^2-3/4*MM0*PP2*QQ3-1/4*
         MM0*PP2*QQ2+1/4*MM0*PP2*QQ1+1/4*MM0*PP2^2+1/2*MM0*PP3*QQ3-1/4*
         MM0*QQ3*QQ2-1/4*MM0*QQ3*QQ1+1/2*MM0*QQ3^2-1/4*MM1*PP1*PP2+1/4*
         MM1*PP1*PP3-1/4*MM1*PP1*QQ1-1/4*MM1*PP2*PP3-1/4*MM1*PP2*QQ3+1/
         2*MM1*PP2*QQ2-1/4*MM1*PP2*QQ1+1/4*MM1*PP2^2-1/4*MM1*PP3*QQ3+1/
         4*MM1*QQ3*QQ1-1/4*PP1*MM2*PP2-1/4*PP1*MM2*PP3-1/4*PP1*MM2*QQ3-
         1/4*PP1*MM2*QQ2+1/2*PP1*MM2*QQ1+PP1*PP2*MM3-1/2*PP1*PP2*PP3+1/
         2*PP1*PP2*QQ3-1/4*PP1*PP2*QQ2-1/4*PP1*PP2*QQ1+PP1*MM3*QQ3-3/4*
         PP1*PP3*QQ3-1/4*PP1*QQ3*QQ1+1/4*PP1^2*MM2-1/2*PP1^2*MM3+1/4*
         PP1^2*PP3+1/4*PP1^2*QQ1+1/4*MM2*PP2*PP3-1/4*MM2*PP2*QQ2-1/4*
         MM2*PP3*QQ3+1/4*MM2*QQ3*QQ2+PP2*MM3*QQ3-3/4*PP2*PP3*QQ3-1/4*
         PP2*QQ3*QQ2-1/2*PP2^2*MM3+1/4*PP2^2*PP3+1/4*PP2^2*QQ2-1/2*MM3*
         QQ3^2+1/2*PP3*QQ3^2)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ2,PP3,MM0,MM1,MM3)*
      T1(3,2)*(-1/4*PP1*PP2-1/4*PP1*PP3-1/4*PP1*QQ3-1/4*PP1*QQ2+1/2*PP1
         *QQ1+1/4*PP1^2+1/4*PP2*PP3-1/4*PP2*QQ2-1/4*PP3*QQ3+1/4*QQ3*QQ2
         )
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP2,QQ1,PP3,MM0,MM2,MM3)*
      T1(3,2)*(-1/4*PP1*PP2+1/4*PP1*PP3-1/4*PP1*QQ1-1/4*PP2*PP3-1/4*PP2
         *QQ3+1/2*PP2*QQ2-1/4*PP2*QQ1+1/4*PP2^2-1/4*PP3*QQ3+1/4*QQ3*QQ1
         )
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(QQ3,QQ1,QQ2,MM1,MM2,MM3)*
      T0(3)*(-1/2*PP1*PP2-1/2*PP1*QQ3+1/4*PP1^2-1/2*PP2*QQ3+1/4*PP2^2+1/
         4*QQ3^2)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(QQ3,QQ1,QQ2,MM1,MM2,MM3)*
      T1(3,2)*(-1/4*PP1*QQ3+1/4*PP1*QQ2-1/4*PP1*QQ1-1/4*PP2*QQ3-1/4*PP2
         *QQ2+1/4*PP2*QQ1+1/2*PP3*QQ3-1/4*QQ3*QQ2-1/4*QQ3*QQ1+1/4*QQ3^2
         );
#if `sorting' == 1
.sort
#endif
id T2(4,0,0)*Targ(PP1?,QQ3?,QQ1?,PP3?,PP2?,QQ2?,MM0?,MM1?,MM2?,MM3?)= +
      Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,MM0,MM1,MM2,MM3)*T0(4)*(MM0)
      +Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,MM0,MM1,MM2,MM3)*T1(4,1)*(1/2*MM0-1/
         2*MM1+1/2*PP1)
      +Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,MM0,MM1,MM2,MM3)*T1(4,2)*(1/2*MM0-1/
         2*MM2+1/2*PP2)
      +Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,MM0,MM1,MM2,MM3)*T1(4,3)*(1/2*MM0-1/
         2*MM3+1/2*PP3)
      +Targ(QQ3,QQ1,QQ2,MM1,MM2,MM3)*T0(3)*(1/2);
#if `sorting' == 1
.sort
#endif
*goto novector4;

#message [reductionDD02: Reduction of tensor-2 integrals finished]
id T1(4,1)*Targ(PP1?,QQ3?,QQ1?,PP3?,PP2?,QQ2?,MM0?,MM1?,MM2?,MM3?)= +
      IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,PP2,MM0,MM1,MM2)*
      T0(3)*(-1/4*PP1*PP2+1/4*PP1*PP3-1/4*PP1*QQ1-1/4*PP2*PP3-1/4*PP2*
         QQ3+1/2*PP2*QQ2-1/4*PP2*QQ1+1/4*PP2^2-1/4*PP3*QQ3+1/4*QQ3*QQ1)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T0(4)*(1/2*MM0*PP1*QQ1+1/4*MM0*PP2*QQ3-1/4*MM0*
         PP2*QQ2-1/4*MM0*PP2*QQ1-1/4*MM0*PP3*QQ3+1/4*MM0*PP3*QQ2-1/4*
         MM0*PP3*QQ1-1/4*MM0*QQ3*QQ1-1/4*MM0*QQ2*QQ1+1/4*MM0*QQ1^2+1/2*
         MM1*PP2*PP3+1/2*MM1*PP2*QQ1-1/4*MM1*PP2^2+1/2*MM1*PP3*QQ1-1/4*
         MM1*PP3^2-1/4*MM1*QQ1^2+1/4*PP1*MM2*PP2-1/4*PP1*MM2*PP3-1/4*
         PP1*MM2*QQ1-1/4*PP1*PP2*MM3-1/4*PP1*PP2*QQ1+1/4*PP1*MM3*PP3-1/
         4*PP1*MM3*QQ1-1/4*PP1*PP3*QQ1+1/4*PP1*QQ1^2-1/4*MM2*PP2*PP3-1/
         4*MM2*PP2*QQ2+1/2*MM2*PP3*QQ3-1/4*MM2*PP3*QQ2-1/4*MM2*PP3*QQ1+
         1/4*MM2*PP3^2+1/4*MM2*QQ2*QQ1-1/4*PP2*MM3*PP3-1/4*PP2*MM3*QQ3+
         1/2*PP2*MM3*QQ2-1/4*PP2*MM3*QQ1-1/4*PP2*PP3*QQ3-1/4*PP2*PP3*
         QQ2+1/2*PP2*PP3*QQ1-1/4*PP2*QQ2*QQ1+1/4*PP2^2*MM3+1/4*PP2^2*
         QQ2-1/4*MM3*PP3*QQ3+1/4*MM3*QQ3*QQ1-1/4*PP3*QQ3*QQ1+1/4*PP3^2*
         QQ3)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ2,PP3,MM0,MM1,MM3)*
      T0(3)*(1/4*PP1*PP2-1/4*PP1*PP3-1/4*PP1*QQ1-1/4*PP2*PP3-1/4*PP2*
         QQ2+1/2*PP3*QQ3-1/4*PP3*QQ2-1/4*PP3*QQ1+1/4*PP3^2+1/4*QQ2*QQ1)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP2,QQ1,PP3,MM0,MM2,MM3)*
      T0(3)*(1/2*PP2*PP3+1/2*PP2*QQ1-1/4*PP2^2+1/2*PP3*QQ1-1/4*PP3^2-1/
         4*QQ1^2)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(QQ3,QQ1,QQ2,MM1,MM2,MM3)*
      T0(3)*(1/2*PP1*QQ1+1/4*PP2*QQ3-1/4*PP2*QQ2-1/4*PP2*QQ1-1/4*PP3*
         QQ3+1/4*PP3*QQ2-1/4*PP3*QQ1-1/4*QQ3*QQ1-1/4*QQ2*QQ1+1/4*QQ1^2)
         ;
#if `sorting' == 1
.sort
#endif
id T1(4,2)*Targ(PP1?,QQ3?,QQ1?,PP3?,PP2?,QQ2?,MM0?,MM1?,MM2?,MM3?)= +
      IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,PP2,MM0,MM1,MM2)*
      T0(3)*(-1/4*PP1*PP2-1/4*PP1*PP3-1/4*PP1*QQ3-1/4*PP1*QQ2+1/2*PP1*
         QQ1+1/4*PP1^2+1/4*PP2*PP3-1/4*PP2*QQ2-1/4*PP3*QQ3+1/4*QQ3*QQ2)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T0(4)*(1/4*MM0*PP1*QQ3-1/4*MM0*PP1*QQ2-1/4*MM0*
         PP1*QQ1+1/2*MM0*PP2*QQ2-1/4*MM0*PP3*QQ3-1/4*MM0*PP3*QQ2+1/4*
         MM0*PP3*QQ1-1/4*MM0*QQ3*QQ2-1/4*MM0*QQ2*QQ1+1/4*MM0*QQ2^2+1/4*
         MM1*PP1*PP2-1/4*MM1*PP1*PP3-1/4*MM1*PP1*QQ1-1/4*MM1*PP2*PP3-1/
         4*MM1*PP2*QQ2+1/2*MM1*PP3*QQ3-1/4*MM1*PP3*QQ2-1/4*MM1*PP3*QQ1+
         1/4*MM1*PP3^2+1/4*MM1*QQ2*QQ1+1/2*PP1*MM2*PP3+1/2*PP1*MM2*QQ2-
         1/4*PP1*PP2*MM3-1/4*PP1*PP2*QQ2-1/4*PP1*MM3*PP3-1/4*PP1*MM3*
         QQ3-1/4*PP1*MM3*QQ2+1/2*PP1*MM3*QQ1-1/4*PP1*PP3*QQ3+1/2*PP1*
         PP3*QQ2-1/4*PP1*PP3*QQ1-1/4*PP1*QQ2*QQ1-1/4*PP1^2*MM2+1/4*
         PP1^2*MM3+1/4*PP1^2*QQ1+1/2*MM2*PP3*QQ2-1/4*MM2*PP3^2-1/4*MM2*
         QQ2^2+1/4*PP2*MM3*PP3-1/4*PP2*MM3*QQ2-1/4*PP2*PP3*QQ2+1/4*PP2*
         QQ2^2-1/4*MM3*PP3*QQ3+1/4*MM3*QQ3*QQ2-1/4*PP3*QQ3*QQ2+1/4*
         PP3^2*QQ3)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ2,PP3,MM0,MM1,MM3)*
      T0(3)*(1/2*PP1*PP3+1/2*PP1*QQ2-1/4*PP1^2+1/2*PP3*QQ2-1/4*PP3^2-1/
         4*QQ2^2)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP2,QQ1,PP3,MM0,MM2,MM3)*
      T0(3)*(1/4*PP1*PP2-1/4*PP1*PP3-1/4*PP1*QQ1-1/4*PP2*PP3-1/4*PP2*
         QQ2+1/2*PP3*QQ3-1/4*PP3*QQ2-1/4*PP3*QQ1+1/4*PP3^2+1/4*QQ2*QQ1)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(QQ3,QQ1,QQ2,MM1,MM2,MM3)*
      T0(3)*(1/4*PP1*QQ3-1/4*PP1*QQ2-1/4*PP1*QQ1+1/2*PP2*QQ2-1/4*PP3*
         QQ3-1/4*PP3*QQ2+1/4*PP3*QQ1-1/4*QQ3*QQ2-1/4*QQ2*QQ1+1/4*QQ2^2)
         ;
#if `sorting' == 1
.sort
#endif
id T1(4,3)*Targ(PP1?,QQ3?,QQ1?,PP3?,PP2?,QQ2?,MM0?,MM1?,MM2?,MM3?)= +
      IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,PP2,MM0,MM1,MM2)*
      T0(3)*(1/2*PP1*PP2+1/2*PP1*QQ3-1/4*PP1^2+1/2*PP2*QQ3-1/4*PP2^2-1/
         4*QQ3^2)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ3,QQ1,PP3,PP2,QQ2,
      MM0,MM1,MM2,MM3)*T0(4)*(-1/4*MM0*PP1*QQ3+1/4*MM0*PP1*QQ2-1/4*MM0*
         PP1*QQ1-1/4*MM0*PP2*QQ3-1/4*MM0*PP2*QQ2+1/4*MM0*PP2*QQ1+1/2*
         MM0*PP3*QQ3-1/4*MM0*QQ3*QQ2-1/4*MM0*QQ3*QQ1+1/4*MM0*QQ3^2-1/4*
         MM1*PP1*PP2+1/4*MM1*PP1*PP3-1/4*MM1*PP1*QQ1-1/4*MM1*PP2*PP3-1/
         4*MM1*PP2*QQ3+1/2*MM1*PP2*QQ2-1/4*MM1*PP2*QQ1+1/4*MM1*PP2^2-1/
         4*MM1*PP3*QQ3+1/4*MM1*QQ3*QQ1-1/4*PP1*MM2*PP2-1/4*PP1*MM2*PP3-
         1/4*PP1*MM2*QQ3-1/4*PP1*MM2*QQ2+1/2*PP1*MM2*QQ1+1/2*PP1*PP2*
         MM3+1/2*PP1*PP2*QQ3-1/4*PP1*PP2*QQ2-1/4*PP1*PP2*QQ1+1/2*PP1*
         MM3*QQ3-1/4*PP1*PP3*QQ3-1/4*PP1*QQ3*QQ1+1/4*PP1^2*MM2-1/4*
         PP1^2*MM3+1/4*PP1^2*QQ1+1/4*MM2*PP2*PP3-1/4*MM2*PP2*QQ2-1/4*
         MM2*PP3*QQ3+1/4*MM2*QQ3*QQ2+1/2*PP2*MM3*QQ3-1/4*PP2*PP3*QQ3-1/
         4*PP2*QQ3*QQ2-1/4*PP2^2*MM3+1/4*PP2^2*QQ2-1/4*MM3*QQ3^2+1/4*
         PP3*QQ3^2)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP1,QQ2,PP3,MM0,MM1,MM3)*
      T0(3)*(-1/4*PP1*PP2-1/4*PP1*PP3-1/4*PP1*QQ3-1/4*PP1*QQ2+1/2*PP1*
         QQ1+1/4*PP1^2+1/4*PP2*PP3-1/4*PP2*QQ2-1/4*PP3*QQ3+1/4*QQ3*QQ2)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(PP2,QQ1,PP3,MM0,MM2,MM3)*
      T0(3)*(-1/4*PP1*PP2+1/4*PP1*PP3-1/4*PP1*QQ1-1/4*PP2*PP3-1/4*PP2*
         QQ3+1/2*PP2*QQ2-1/4*PP2*QQ1+1/4*PP2^2-1/4*PP3*QQ3+1/4*QQ3*QQ1)
      +IGram(3,PP1,QQ3,QQ1,PP3,PP2,QQ2)*Targ(QQ3,QQ1,QQ2,MM1,MM2,MM3)*
      T0(3)*(-1/4*PP1*QQ3+1/4*PP1*QQ2-1/4*PP1*QQ1-1/4*PP2*QQ3-1/4*PP2*
         QQ2+1/4*PP2*QQ1+1/2*PP3*QQ3-1/4*QQ3*QQ2-1/4*QQ3*QQ1+1/4*QQ3^2)
         ;
#if `sorting' == 1
.sort
#endif
#message [reductionDD02: Reduction of vector integral finished]
label novector4;
**----------------------------------------------------------------------
** 3-point functions
#message [reductionDD02: ** Beginning reduction of 3-point integrals] **
id T2(3,1,1)*Targ(PP1?,QQ3?,PP2?,MM0?,MM1?,MM2?)= +IGram(2,PP1,QQ3,PP2)
      *Targ(PP1,MM0,MM1)*T1(2,1)*(-1/2*PP1-1/2*PP2+1/2*QQ3)
      +IGram(2,PP1,QQ3,PP2)*Targ(PP1,QQ3,PP2,MM0,MM1,MM2)*T0(3)*(-MM0*
         PP2)
      +IGram(2,PP1,QQ3,PP2)*Targ(PP1,QQ3,PP2,MM0,MM1,MM2)*T1(3,1)*(1/2*
         MM0*PP1-MM0*PP2-1/2*MM0*QQ3+3/2*MM1*PP2-1/2*PP1*MM2-PP1*PP2-1/
         2*MM2*PP2+1/2*MM2*QQ3-1/2*PP2*QQ3+1/2*PP2^2)
      +IGram(2,PP1,QQ3,PP2)*Targ(PP1,QQ3,PP2,MM0,MM1,MM2)*T1(3,2)*(-1/2
         *MM0*PP2+1/2*MM2*PP2-1/2*PP2^2)
      +IGram(2,PP1,QQ3,PP2)*Targ(QQ3,MM1,MM2)*T0(2)*(-1/2*PP1+1/2*QQ3)
      +IGram(2,PP1,QQ3,PP2)*Targ(QQ3,MM1,MM2)*T1(2,1)*(-1/2*PP1+1/2*PP2
         +1/2*QQ3)
      +IGram(2,PP1,QQ3,PP2)*(-1/2*PP2);
#if `sorting' == 1
.sort
#endif
id T2(3,1,2)*Targ(PP1?,QQ3?,PP2?,MM0?,MM1?,MM2?)= +IGram(2,PP1,QQ3,PP2)
      *Targ(PP1,QQ3,PP2,MM0,MM1,MM2)*T0(3)*(1/2*MM0*PP1+1/2*MM0*PP2-1/2
         *MM0*QQ3)
      +IGram(2,PP1,QQ3,PP2)*Targ(PP1,QQ3,PP2,MM0,MM1,MM2)*T1(3,1)*(1/4*
         MM0*PP1+1/4*MM0*PP2-1/4*MM0*QQ3-1/4*MM1*PP1-1/4*MM1*PP2+1/4*
         MM1*QQ3+1/4*PP1*PP2-1/4*PP1*QQ3+1/4*PP1^2)
      +IGram(2,PP1,QQ3,PP2)*Targ(PP1,QQ3,PP2,MM0,MM1,MM2)*T1(3,2)*(3/4*
         MM0*PP1-1/4*MM0*PP2-3/4*MM0*QQ3+MM1*PP2-3/4*PP1*MM2-1/4*PP1*
         PP2-3/4*MM2*PP2+3/4*MM2*QQ3-3/4*PP2*QQ3+3/4*PP2^2)
      +IGram(2,PP1,QQ3,PP2)*Targ(PP2,MM0,MM2)*T1(2,1)*(PP2)
      +IGram(2,PP1,QQ3,PP2)*Targ(QQ3,MM1,MM2)*T0(2)*(1/4*PP1+1/4*PP2-1/
         4*QQ3)
      +IGram(2,PP1,QQ3,PP2)*Targ(QQ3,MM1,MM2)*T1(2,1)*(1/2*PP1-1/2*PP2-
         1/2*QQ3)
      +IGram(2,PP1,QQ3,PP2)*(1/4*PP1+1/4*PP2-1/4*QQ3);
#if `sorting' == 1
.sort
#endif
id T2(3,2,2)*Targ(PP1?,QQ3?,PP2?,MM0?,MM1?,MM2?)= +IGram(2,PP1,QQ3,PP2)
      *Targ(PP1,QQ3,PP2,MM0,MM1,MM2)*T0(3)*(-MM0*PP1)
      +IGram(2,PP1,QQ3,PP2)*Targ(PP1,QQ3,PP2,MM0,MM1,MM2)*T1(3,1)*(-1/2
         *MM0*PP1+1/2*MM1*PP1-1/2*PP1^2)
      +IGram(2,PP1,QQ3,PP2)*Targ(PP1,QQ3,PP2,MM0,MM1,MM2)*T1(3,2)*(-MM0
         *PP1+1/2*MM0*PP2-1/2*MM0*QQ3-1/2*MM1*PP1-1/2*MM1*PP2+1/2*MM1*
         QQ3+3/2*PP1*MM2-PP1*PP2-1/2*PP1*QQ3+1/2*PP1^2)
      +IGram(2,PP1,QQ3,PP2)*Targ(PP2,MM0,MM2)*T1(2,1)*(-1/2*PP1-1/2*PP2
         +1/2*QQ3)
      +IGram(2,PP1,QQ3,PP2)*Targ(QQ3,MM1,MM2)*T0(2)*(-1/2*PP1)
      +IGram(2,PP1,QQ3,PP2)*Targ(QQ3,MM1,MM2)*T1(2,1)*(-1/2*PP1+1/2*PP2
         -1/2*QQ3)
      +IGram(2,PP1,QQ3,PP2)*(-1/2*PP1);
#if `sorting' == 1
.sort
#endif
id T2(3,0,0)*Targ(PP1?,QQ3?,PP2?,MM0?,MM1?,MM2?)= +Targ(PP1,QQ3,PP2,MM0
      ,MM1,MM2)*T0(3)*(1/2*MM0)
      +Targ(PP1,QQ3,PP2,MM0,MM1,MM2)*T1(3,1)*(1/4*MM0-1/4*MM1+1/4*PP1)
      +Targ(PP1,QQ3,PP2,MM0,MM1,MM2)*T1(3,2)*(1/4*MM0-1/4*MM2+1/4*PP2)
      +Targ(QQ3,MM1,MM2)*T0(2)*(1/4)
      +1/4;
#if `sorting' == 1
.sort
#endif
#message [reductionDD02: Reduction of tensor-2 integrals finished]
*goto novector3;

id T1(3,1)*Targ(PP1?,QQ3?,PP2?,MM0?,MM1?,MM2?)= +IGram(2,PP1,QQ3,PP2)*
      Targ(PP1,MM0,MM1)*T0(2)*(-1/2*PP1-1/2*PP2+1/2*QQ3)
      +IGram(2,PP1,QQ3,PP2)*Targ(PP1,QQ3,PP2,MM0,MM1,MM2)*T0(3)*(1/2*
         MM0*PP1-1/2*MM0*PP2-1/2*MM0*QQ3+MM1*PP2-1/2*PP1*MM2-1/2*PP1*
         PP2-1/2*MM2*PP2+1/2*MM2*QQ3-1/2*PP2*QQ3+1/2*PP2^2)
      +IGram(2,PP1,QQ3,PP2)*Targ(PP2,MM0,MM2)*T0(2)*(PP2)
      +IGram(2,PP1,QQ3,PP2)*Targ(QQ3,MM1,MM2)*T0(2)*(1/2*PP1-1/2*PP2-1/
         2*QQ3);
#if `sorting' == 1
.sort
#endif
id T1(3,2)*Targ(PP1?,QQ3?,PP2?,MM0?,MM1?,MM2?)= +IGram(2,PP1,QQ3,PP2)*
      Targ(PP1,MM0,MM1)*T0(2)*(PP1)
      +IGram(2,PP1,QQ3,PP2)*Targ(PP1,QQ3,PP2,MM0,MM1,MM2)*T0(3)*(-1/2*
         MM0*PP1+1/2*MM0*PP2-1/2*MM0*QQ3-1/2*MM1*PP1-1/2*MM1*PP2+1/2*
         MM1*QQ3+PP1*MM2-1/2*PP1*PP2-1/2*PP1*QQ3+1/2*PP1^2)
      +IGram(2,PP1,QQ3,PP2)*Targ(PP2,MM0,MM2)*T0(2)*(-1/2*PP1-1/2*PP2+1/
         2*QQ3)
      +IGram(2,PP1,QQ3,PP2)*Targ(QQ3,MM1,MM2)*T0(2)*(-1/2*PP1+1/2*PP2-1/
         2*QQ3);
#if `sorting' == 1
.sort
#endif
#message [reductionDD02: Reduction of vector integral finished]
label novector3;
**----------------------------------------------------------------------
** 2-point functions
#message [reductionDD02: ** Beginning reduction of 2-point integrals] **
id T2(2,1,1)*Targ(PP1?,MM0?,MM1?)= +IGram(1,PP1)*Targ(MM1)*T0(1)*(2/3)
      +IGram(1,PP1)*Targ(PP1,MM0,MM1)*T0(2)*(-2/3*MM0)
      +IGram(1,PP1)*Targ(PP1,MM0,MM1)*T1(2,1)*(-4/3*MM0+4/3*MM1-4/3*PP1
         )
      +IGram(1,PP1)*(-1/3*MM0-1/3*MM1+1/9*PP1);
#if `sorting' == 1
.sort
#endif
id T2(2,0,0)*Targ(PP1?,MM0?,MM1?)= +Targ(MM1)*T0(1)*(1/6)
      +Targ(PP1,MM0,MM1)*T0(2)*(1/3*MM0)
      +Targ(PP1,MM0,MM1)*T1(2,1)*(1/6*MM0-1/6*MM1+1/6*PP1)
      +1/6*MM0+1/6*MM1-1/18*PP1;
#if `sorting' == 1
.sort
#endif
*goto novector2;
#message [reductionDD02: Reduction of tensor-2 integrals finished]
id T1(2,1)*Targ(PP1?,MM0?,MM1?)= +IGram(1,PP1)*Targ(MM0)*T0(1)*(1)
      +IGram(1,PP1)*Targ(MM1)*T0(1)*(-1)
      +IGram(1,PP1)*Targ(PP1,MM0,MM1)*T0(2)*(-MM0+MM1-PP1);
#if `sorting' == 1
.sort
#endif
label novector2;
#message [reductionDD02: Reduction of vector integral finished]

**----------------------------------------------------------------------
** Symmetry of Gram Determinants and Scalar integrals
#call argsymmetries()

#endprocedure
*$Id: reductionDD02.prc,v 1.5 2004/10/08 14:28:12 alorca Exp $
